// -*- C++ -*- //

#ifndef ALGOWIN_H
#define ALGOWIN_H

class AlgoWin;

#include <all_include.h>
#include <algobox.h>
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

enum {GENERAL, ALGO_NUM}; // algorithm IDs;

class AlgoWin : public Gtk::Dialog
{
private:
  AlgoBox * ab;

protected:
  sigc::signal<void, AlgoWin *> signal_closed;  

public:
  sigc::signal<void, AlgoWin *> signal_closing()
  {
    return signal_closed;
  }

  AlgoWin(int algoid, std::vector<std::string> tabnames)
    {
      Gtk::VBox * vbox=get_vbox();
      
      ab=new AlgoBox(tabnames);
      
      vbox->pack_start(*ab);
      
      add_button(Gtk::Stock::OK, Gtk::RESPONSE_OK);
      
      show_all_children();
    };

  void update_tablist(std::vector<std::string> tabnames)
  {
    ab->update_tablist(tabnames);
  }

  void on_hide()
  {
    signal_closed.emit(this);
    Gtk::Dialog::on_hide();
  }
};
#endif //ALGOWIN_H
